#!/usr/bin/env node
"use strict";

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var main = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(_argv) {
    var _this = this;

    var argv, notifier, getMsgPayload, renderInput, _username, _ref4, username, _password, _ref5, password, loginSpinner, session, userAccountId, mainLoop, instagramAccounts, parseMessageString, ClientInbox, inboxBuffer, pending, getOlder, getAllOlder, refreshInbox, fetchOlderToBuffer, fetchAllToBuffer, createChoicesFromBuffer, inboxSpinner, CHOICE_FETCH_OLDER, CHOICE_FETCH_ALL, CHOICE_REFRESH, _loop;

    return _regenerator2.default.wrap(function _callee9$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            argv = mri(_argv, {
              string: ["username", "password"],
              boolean: ["version", "help", "persist"],
              alias: {
                username: "u",
                password: "p",
                interval: "i",
                version: "v",
                help: "h",
                persist: "s"
              }
            });

            console.log(chalk.dim("igdm-cli v" + pkg.version));
            notifier = updateNotifier({ pkg: pkg });

            notifier.notify();
            if (argv.version) process.exit(0);
            if (argv.help) {
              console.log("\nUsage:\n    $  igdm\n    $  igdm [-h] | [-v] | [-s] | [-u <username>] [-p <password>] [-i <polling interval>]\n    $  igdm [--help] | [--version] | [--persist] | [--username=<username>] [--password=<password>] [--interval=<polling interval>]\n\nOptions:\n    -h, --help                  Show this screen.\n    -v, --version               Show version.\n    -s, --persist               Save session in disk.\n    -u, --username <username>   Set Instagram username. [default: will prompt]\n    -p, --password <password>   Set Instagram password. [default: will prompt]\n    -i, --interval <interval>   Set polling interval (seconds) in chat rooms [default: 5]\n\nNotes:\n    In chatroom mode, exit by entering '/end'. Manually refresh the room by entering '/refresh'.\n    ");
              process.exit(0);
            }

            if (!(argv.interval && typeof argv.interval !== "number")) {
              _context11.next = 8;
              break;
            }

            throw new Error("<interval> argument must be a number. Instead it's a " + (0, _typeof3.default)(argv.interval));

          case 8:
            getMsgPayload = function getMsgPayload(msgToSend) {
              return msgToSend.join("");
            };

            renderInput = function () {
              var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref2) {
                var items = _ref2.items,
                    title = _ref2.title,
                    message = _ref2.message;
                var threadItemsStr;
                return _regenerator2.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        threadItemsStr = items.length ? items.sort(function (a, b) {
                          return a.created - b.created;
                        }).map(function (i) {
                          return parseMessageString(i);
                        }).join("\n") : "There are no messages yet.";

                        logUpdate("" + threadItemsStr + (pending.length > 0 ? "\n" + pending.join("\n") : "") + "\n\n" + chalk.dim("`/refresh` to refresh chat") + "\n" + chalk.dim("`/end` to end chat") + "\nReply to " + title + " " + chalk.green("›") + " " + getMsgPayload(message));

                      case 2:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              }));

              return function renderInput(_x2) {
                return _ref3.apply(this, arguments);
              };
            }();

            _username = void 0;

            if (argv.username) {
              _context11.next = 19;
              break;
            }

            _context11.next = 14;
            return inquirer.prompt({
              name: "username",
              message: "Instagram Username: "
            });

          case 14:
            _ref4 = _context11.sent;
            username = _ref4.username;

            _username = username;
            _context11.next = 20;
            break;

          case 19:
            _username = argv.username;

          case 20:

            device = new Client.Device("" + _username + Date.now());
            storage = argv.persist ? new Client.CookieFileStorage(__dirname + ("/ig-cookie." + _username + ".json")) : new Client.CookieMemoryStorage();

            _password = void 0;

            if (argv.password) {
              _context11.next = 31;
              break;
            }

            _context11.next = 26;
            return inquirer.prompt({
              name: "password",
              message: "Instagram password: ",
              type: "password"
            });

          case 26:
            _ref5 = _context11.sent;
            password = _ref5.password;

            _password = password;
            _context11.next = 32;
            break;

          case 31:
            _password = argv.password;

          case 32:
            loginSpinner = ora("Logging in as " + _username).start();
            session = void 0;
            _context11.prev = 34;
            _context11.next = 37;
            return Client.Session.create(device, storage, _username, _password);

          case 37:
            session = _context11.sent;
            _context11.next = 45;
            break;

          case 40:
            _context11.prev = 40;
            _context11.t0 = _context11["catch"](34);

            console.error(_context11.t0);
            console.log("can't login");
            process.exit(1);

          case 45:

            loginSpinner.succeed("You are logged in as " + _username);

            _context11.next = 48;
            return storage.getAccountId();

          case 48:
            userAccountId = _context11.sent;
            mainLoop = true;
            instagramAccounts = {};

            parseMessageString = function parseMessageString(threadItem) {
              var senderId = threadItem.userId;
              var senderUsername = senderId === userAccountId ? chalk.cyan("You") : instagramAccounts[senderId] && chalk.magenta(instagramAccounts[senderId].username) || chalk.red("A User");

              var payloadType = threadItem.itemType;
              var payloadMessage = void 0;
              var payloadCreated = threadItem.created;
              switch (payloadType) {
                case "text":
                  payloadMessage = "\"" + threadItem.text + "\"";
                  break;
                case "media":
                  payloadMessage = (0, _stringify2.default)(threadItem.media);
                  payloadMessage = "[media] \u203A " + chalk.underline(threadItem.media[0].url);
                  break;
                case "like":
                  payloadMessage = "♥";
                  break;
                default:
                  payloadMessage = "[a non-text message of type " + payloadType + "]";
                  break;
              }
              return senderUsername + ": " + chalk.white(payloadMessage) + " " + chalk.dim("[" + moment(payloadCreated).fromNow() + "]");
            };

            ClientInbox = void 0;
            inboxBuffer = [];
            pending = [];

            getOlder = function () {
              var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.next = 2;
                        return ClientInbox.get();

                      case 2:
                        _context2.t0 = function (thread) {
                          return thread.parseParams(thread.getParams());
                        };

                        return _context2.abrupt("return", _context2.sent.map(_context2.t0));

                      case 4:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, _this);
              }));

              return function getOlder() {
                return _ref6.apply(this, arguments);
              };
            }();

            getAllOlder = function () {
              var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.next = 2;
                        return ClientInbox.all();

                      case 2:
                        _context3.t0 = function (thread) {
                          return thread.parseParams(thread.getParams());
                        };

                        return _context3.abrupt("return", _context3.sent.map(_context3.t0));

                      case 4:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3, _this);
              }));

              return function getAllOlder() {
                return _ref7.apply(this, arguments);
              };
            }();

            refreshInbox = function () {
              var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
                return _regenerator2.default.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.next = 2;
                        return new Client.Feed.Inbox(session);

                      case 2:
                        ClientInbox = _context4.sent;
                        _context4.next = 5;
                        return getOlder();

                      case 5:
                        inboxBuffer = _context4.sent;

                      case 6:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, _this);
              }));

              return function refreshInbox() {
                return _ref8.apply(this, arguments);
              };
            }();

            fetchOlderToBuffer = function () {
              var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
                return _regenerator2.default.wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        _context5.t0 = [];
                        _context5.t1 = (0, _toConsumableArray3.default)(inboxBuffer);
                        _context5.t2 = _toConsumableArray3.default;
                        _context5.next = 5;
                        return getOlder();

                      case 5:
                        _context5.t3 = _context5.sent;
                        _context5.t4 = (0, _context5.t2)(_context5.t3);
                        inboxBuffer = _context5.t0.concat.call(_context5.t0, _context5.t1, _context5.t4);

                      case 8:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5, _this);
              }));

              return function fetchOlderToBuffer() {
                return _ref9.apply(this, arguments);
              };
            }();

            fetchAllToBuffer = function () {
              var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        _context6.t0 = [];
                        _context6.t1 = (0, _toConsumableArray3.default)(inboxBuffer);
                        _context6.t2 = _toConsumableArray3.default;
                        _context6.next = 5;
                        return getAllOlder();

                      case 5:
                        _context6.t3 = _context6.sent;
                        _context6.t4 = (0, _context6.t2)(_context6.t3);
                        inboxBuffer = _context6.t0.concat.call(_context6.t0, _context6.t1, _context6.t4);

                      case 8:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6, _this);
              }));

              return function fetchAllToBuffer() {
                return _ref10.apply(this, arguments);
              };
            }();

            createChoicesFromBuffer = function createChoicesFromBuffer() {
              return inboxBuffer
              // .filter(m => !m.threadTitle.includes("")) // CUSTOM FILTER
              .filter(function (m) {
                return m.accounts.length;
              }).map(function (m) {
                return {
                  name: chalk.underline("[" + m.threadTitle + "]") + " - " + parseMessageString(m.items[0]),
                  value: m.threadId,
                  short: m.threadTitle
                };
              });
            };

            inboxSpinner = ora("Opening inbox").start();

            inboxSpinner.text = "Fetching recent threads";
            _context11.next = 65;
            return refreshInbox();

          case 65:
            inboxSpinner.succeed("Recent threads");

            CHOICE_FETCH_OLDER = {
              name: "Fetch older items",
              value: "CHOICE_FETCH_OLDER",
              short: "Fetch older items"
            };
            CHOICE_FETCH_ALL = {
              name: "Fetch all items",
              value: "CHOICE_FETCH_ALL",
              short: "Fetch all items"
            };
            CHOICE_REFRESH = {
              name: "Refresh inbox",
              value: "CHOICE_REFRESH",
              short: "Refresh inbox"
            };
            _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop() {
              var choices, choicesWithMenu, _ref11, id, chatLoop, thread, _loop2;

              return _regenerator2.default.wrap(function _loop$(_context10) {
                while (1) {
                  switch (_context10.prev = _context10.next) {
                    case 0:
                      inboxBuffer.forEach(function (m) {
                        return m.accounts.forEach(function (a) {
                          if (!instagramAccounts[a.id]) {
                            instagramAccounts[a.id] = a;
                          }
                        });
                      });
                      choices = createChoicesFromBuffer();
                      choicesWithMenu = ClientInbox.isMoreAvailable() ? [].concat((0, _toConsumableArray3.default)(choices), [CHOICE_FETCH_OLDER, CHOICE_FETCH_ALL, CHOICE_REFRESH]) : [].concat((0, _toConsumableArray3.default)(choices), [CHOICE_REFRESH]);
                      _context10.next = 5;
                      return inquirer.prompt({
                        name: "id",
                        message: "Inbox threads: ",
                        type: "list",
                        choices: choicesWithMenu
                      });

                    case 5:
                      _ref11 = _context10.sent;
                      id = _ref11.id;
                      chatLoop = !("" + id).includes("CHOICE_") ? true : false;
                      thread = void 0;

                      if (!(id === CHOICE_FETCH_ALL.value)) {
                        _context10.next = 14;
                        break;
                      }

                      _context10.next = 12;
                      return fetchAllToBuffer();

                    case 12:
                      _context10.next = 22;
                      break;

                    case 14:
                      if (!(id === CHOICE_FETCH_OLDER.value)) {
                        _context10.next = 19;
                        break;
                      }

                      _context10.next = 17;
                      return fetchOlderToBuffer();

                    case 17:
                      _context10.next = 22;
                      break;

                    case 19:
                      if (!(id === CHOICE_REFRESH.value)) {
                        _context10.next = 22;
                        break;
                      }

                      _context10.next = 22;
                      return refreshInbox();

                    case 22:
                      _loop2 = /*#__PURE__*/_regenerator2.default.mark(function _loop2() {
                        var Thread, thread, threadTitle, msgToSend, updateThread, interval, threadRefreshInterval;
                        return _regenerator2.default.wrap(function _loop2$(_context9) {
                          while (1) {
                            switch (_context9.prev = _context9.next) {
                              case 0:
                                _context9.next = 2;
                                return Client.Thread.getById(session, id);

                              case 2:
                                Thread = _context9.sent;
                                thread = Thread.parseParams(Thread.getParams());
                                threadTitle = "[" + thread.threadTitle + "]";
                                msgToSend = [];

                                updateThread = function () {
                                  var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
                                    return _regenerator2.default.wrap(function _callee7$(_context7) {
                                      while (1) {
                                        switch (_context7.prev = _context7.next) {
                                          case 0:
                                            _context7.next = 2;
                                            return Client.Thread.getById(session, id);

                                          case 2:
                                            Thread = _context7.sent;

                                            thread = Thread.parseParams(Thread.getParams());
                                            renderInput({
                                              items: thread.items,
                                              title: threadTitle,
                                              message: msgToSend
                                            });

                                          case 5:
                                          case "end":
                                            return _context7.stop();
                                        }
                                      }
                                    }, _callee7, _this);
                                  }));

                                  return function updateThread() {
                                    return _ref12.apply(this, arguments);
                                  };
                                }();

                                interval = ms(argv.interval + "s") || ms("5s");
                                threadRefreshInterval = setInterval(updateThread, interval);


                                renderInput({
                                  items: thread.items,
                                  title: threadTitle,
                                  message: msgToSend
                                });

                                _context9.next = 12;
                                return new _promise2.default(function (resolve) {
                                  var keypressHandler = function () {
                                    var _ref13 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(ch) {
                                      var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
                                      var msgPayload;
                                      return _regenerator2.default.wrap(function _callee8$(_context8) {
                                        while (1) {
                                          switch (_context8.prev = _context8.next) {
                                            case 0:
                                              if (!hasAnsi(key.sequence)) {
                                                _context8.next = 2;
                                                break;
                                              }

                                              return _context8.abrupt("return");

                                            case 2:
                                              if (key.ctrl && key.name === "c") {
                                                if (msgToSend.length <= 1) {
                                                  logUpdate();
                                                  // readline.moveCursor(process.stdout, 0, -1);
                                                }
                                                process.exit();
                                              }

                                              if (!(key.name === "return" || key.ctrl && key.name === "u")) {
                                                _context8.next = 34;
                                                break;
                                              }

                                              msgPayload = getMsgPayload(msgToSend);

                                              if (!(msgToSend.length <= 0)) {
                                                _context8.next = 7;
                                                break;
                                              }

                                              return _context8.abrupt("return");

                                            case 7:
                                              if (!(msgPayload === "/end")) {
                                                _context8.next = 18;
                                                break;
                                              }

                                              logUpdate("[*] Ending chat with " + threadTitle + ", refreshing inbox.");
                                              _context8.next = 11;
                                              return refreshInbox();

                                            case 11:
                                              logUpdate("[*] Ended chat with " + threadTitle + ".");
                                              process.stdin.pause();
                                              process.stdin.removeListener("keypress", keypressHandler);
                                              chatLoop = false;
                                              resolve(key);
                                              _context8.next = 32;
                                              break;

                                            case 18:
                                              if (!(msgPayload === "/refresh")) {
                                                _context8.next = 25;
                                                break;
                                              }

                                              logUpdate("[*] Refreshing");
                                              process.stdin.pause();
                                              process.stdin.removeListener("keypress", keypressHandler);
                                              resolve(key);
                                              _context8.next = 32;
                                              break;

                                            case 25:
                                              msgToSend.length = 0;
                                              pending.push("You: " + chalk.white(msgPayload) + " " + chalk.dim("[sending...]"));
                                              renderInput({
                                                items: thread.items,
                                                title: threadTitle,
                                                message: msgToSend
                                              });
                                              _context8.next = 30;
                                              return Thread.broadcastText(msgPayload);

                                            case 30:
                                              pending = pending.slice(1);
                                              updateThread();

                                            case 32:
                                              _context8.next = 35;
                                              break;

                                            case 34:
                                              if (key.name === "backspace") {
                                                msgToSend.pop();
                                                renderInput({
                                                  items: thread.items,
                                                  title: threadTitle,
                                                  message: msgToSend
                                                });
                                              } else {
                                                msgToSend.push(ch);
                                                renderInput({
                                                  items: thread.items,
                                                  title: threadTitle,
                                                  message: msgToSend
                                                });
                                              }

                                            case 35:
                                            case "end":
                                              return _context8.stop();
                                          }
                                        }
                                      }, _callee8, _this);
                                    }));

                                    return function keypressHandler(_x4) {
                                      return _ref13.apply(this, arguments);
                                    };
                                  }();
                                  process.stdin.on("keypress", keypressHandler);
                                  process.stdin.setRawMode(true);
                                  process.stdin.resume();
                                });

                              case 12:
                                clearInterval(threadRefreshInterval);

                              case 13:
                              case "end":
                                return _context9.stop();
                            }
                          }
                        }, _loop2, _this);
                      });

                    case 23:
                      if (!chatLoop) {
                        _context10.next = 27;
                        break;
                      }

                      return _context10.delegateYield(_loop2(), "t0", 25);

                    case 25:
                      _context10.next = 23;
                      break;

                    case 27:
                    case "end":
                      return _context10.stop();
                  }
                }
              }, _loop, _this);
            });

          case 70:
            if (!mainLoop) {
              _context11.next = 74;
              break;
            }

            return _context11.delegateYield(_loop(), "t1", 72);

          case 72:
            _context11.next = 70;
            break;

          case 74:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee9, this, [[34, 40]]);
  }));

  return function main(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inquirer = require("inquirer");
var mri = require("mri");
var logUpdate = require("log-update");
var chalk = require("chalk");
var hasAnsi = require("has-ansi");
var ora = require("ora");
var moment = require("moment");
var ms = require("ms");
var updateNotifier = require("update-notifier");
var pkg = require("../package.json");
var Client = require("instagram-private-api").V1;

var device = void 0,
    storage = void 0;

main(process.argv).catch(function (err) {
  console.log(err);
  process.exit(1);
});